local L = LibStub("AceLocale-3.0"):GetLocale("Protwarbar")

function PWBLog:OnInitialize()
	self.db = Protwarbar.db.profile.PWBLog
	self.DPSLOGCOUNT = 5
	self.dpslog = {}

	for i = 1, self.DPSLOGCOUNT do
		self.dpslog[i] = 0
	end

	self.dpslog_count = 1

	PWBLog:BuildGui()

	self:RegisterMessage("PWB_ABILITIES_LOADED")
	self:RegisterMessage("PWB_PROFILE_CHANGED")
	self:RegisterMessage("PWB_REFRESH_CONFIG")
	self:RegisterMessage("PWB_UPDATE_VISIBILITY")
end

function PWBLog:OnEnable()
	self:RegisterEvent("UNIT_COMBAT")
	self:ScheduleRepeatingTimer("QuickTimer", 1)
end

function PWBLog:PWB_PROFILE_CHANGED()
	self.db = Protwarbar.db.profile.PWBLog
end

function PWBLog:PWB_ABILITIES_LOADED()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("PWBLog", PWBLog:CreateOptions());
	AceConfig:AddToBlizOptions("PWBLog", L["Log"], "Protwarbar");
end

function PWBLog:RefreshConfig()
	self:UpdateStyling()
	self:UpdateVisiblity()
end

function PWBLog:PWB_REFRESH_CONFIG()
	self:RefreshConfig()
end

function PWBLog:PWB_UPDATE_VISIBILITY()
	self:UpdateVisiblity()
end

function PWBLog:QuickTimer()
	local dps = 0

	for i = 1, self.DPSLOGCOUNT do
		dps = dps + self.dpslog[i]
	end

	self.dpslog_count = self.dpslog_count + 1

	if self.dpslog_count > self.DPSLOGCOUNT then
		self.dpslog_count = 1
	end

	self.dpslog[self.dpslog_count] = 0

	if dps > 0 then
		dps = dps / self.DPSLOGCOUNT / 1000
	end

	PWBTopText:SetText(string.format("%.1f K", dps))

end

function PWBLog:UNIT_COMBAT(event, unit, action, modifier, dmg, dmgType)

	if unit == "player" then
		-- Protwarbar:Print(unit .. "2 " ..  action .. "3 " ..  modifier .. "4 " ..  dmg .. "5 " ..  dmgType)
		if action == "WOUND" then
			self.dpslog[self.dpslog_count] = self.dpslog[self.dpslog_count] + dmg
		end
	end
end